Var         pis, xs, rs, pi, x, r, q, ys, as, vs, pih, vsx, a, vpi, s, y,
            obs_rs, obs_pi, obs_xs, obs_q, obs_r, obs_pis, obs_x;
Varexo      esr, esa, esx, er, ea, epi, ex;
Parameters  BETA, K, SIGMA, RHOx, RHOa, ALPHA, IOTA, 
            TAU, THETA, RHOr, ALPHApi, ALPHAx, PHIt, RHOpi, PHI, RHOsa, 
            RHOsx, RHOsr, ALPHAspi, ALPHAsx, SIGMAa, OMEGA;
 
K = 0.2 ;
BETA = 0.99;
ALPHA = 0.3;
SIGMA = 1;
TAU = 1;
IOTA = 1;
PHI = 3;
PHIt= 2;
 
THETA = 0.5;
 
RHOx = 0.85;
RHOa = 0.8;
 
 
RHOr = 0.8;
ALPHAx = 0.05;
ALPHApi= 0.4;
 
RHOsr = 0.8;
ALPHAsx = 0.05;
ALPHApis= 0.4;
 
RHOpi = 0.8;
RHOsa = 0.7;
RHOsx = 0.7;
 
SIGMAa = 0.01;
SIGMAx = 0.01;
SIGMApi = 0.01;
SIGMAr = 0.01;
SIGMAas = 0.01; 
SIGMAxs = 0.01;
SIGMArs = 0.01;
 

 
model;
 
 
SIGMAa = SIGMA/((1-ALPHA)+ALPHA*OMEGA);
OMEGA = SIGMA*TAU+(1-ALPHA)*(SIGMA*IOTA-1);
PHIa =(1+PHI)/(SIGMA + PHI);
PHIb = (SIGMAa-SIGMA)/(SIGMAa+PHI);
PHIc = ALPHA*(OMEGA-1)+PHIb;3
PHId = (1+PHI)/(SIGMAa+PHI);
LAMDA = (1-THETA)*(1-THETA*BETA)/THETA;
Ka = lamda*(SIGMAa+PHI);

// phlip nuoc lon
pis = BETA*pis(+1)+xs*Ka;

// IS nuoc lon
xs = xs(+1)-(1/SIGMA)*(rs-pis(+1))-PHIa*(1-RHOsa)*as+((1-RHOsx)/SIGMA)*vsx;

// taylor nuoc lon
rs = RHOsr*rs(-1)+ALPHAspi*pis+ALPHAsx*xs+esr;
 
// output tiem nang 
xs = ys-PHIa*as;
 
// IS
x= x(+1)-(1/SIGMAa)*(r-pih(+1))+PHIc*(ys(+1)-ys)+((1-RHOx)*(1-PHIb)/SIGMA)*vx+((1-RHOsx)/SIGMA)*PHIc*vsx-PHId*(1-RHOa)*a;

// phlip
pih = BETA*pih(+1)+Ka*x+vpi;
 
// taylor
r = RHOr*r(-1)+ALPHApi*pi+ALPHAx*x+er;
 
// lien he giua lam phat hang hoa va lam phat trong nuoc
pi = pih +ALPHA*(s-s(-1));
 
q = q(-1)+(1-ALPHA)*(s-s(-1));
 
s = SIGMAa*(y-ys)-(SIGMAa/SIGMA)*(vx-vsx);
 
x = y - PHIt*ys-(PHIb/SIGMA)*(vx-vsx)-PHId*a;
 
//shock 
a = RHOa*a(-1)+ea;
vpi = RHOpi*vpi(-1)+epi;
vx = RHOx*vx(-1)+ex;
as= RHOsa*as(-1)+esa;
vsx = RHOsx*vsx(-1)+esx;
 
 
//observed variables
obs_rs   = log(1+rs/(4*100));
obs_pi  =  log(pi);
obs_xs   = log(xs); 
obs_q   = log(q);
obs_r   = log(1+r/(4*100));
obs_pis  = log(pis);
obs_x   = log(x); 
   
    
end;
 
initval;
pis = 0;
xs = 0;
rs = 0;
pi = 0;
x = 0;
r = 0;
q = 0;
ys = 0;
s = 0;
y = 0;
end;

steady;

check;

shocks; 
var er; stderr SIGMAr;
end;


estimated_params;
THETA,beta_pdf,0.60,0.10;
RHOr,beta_pdf,0.80,0.02;
ALPHAx,normal_pdf,0.05,0.10;
ALPHApi,normal_pdf,0.40,0.10;
RHOsr,beta_pdf,0.80,0.10;
ALPHAsx,normal_pdf,0.05,0.10;
ALPHAspi,normal_pdf,0.40,0.10;
RHOpi,beta_pdf,0.80,0.02;
RHOsa,beta_pdf,0.70,0.5;
RHOsx,beta_pdf,0.70,0.10;
stderr ea, inv_gamma_pdf, 2, inf;
stderr ex, inv_gamma_pdf, 2, inf;
stderr epi, inv_gamma_pdf, 2, inf;
stderr er, inv_gamma_pdf, 2, inf;
stderr esa, inv_gamma_pdf, 2, inf;
stderr esx, inv_gamma_pdf, 2, inf;
stderr esr, inv_gamma_pdf, 2, inf;
end;

varobs xs pis rs x pi r q;

stoch_simul(dr_algo = 0, order = 1, periods = 5000, irf=40);

estimation(datafile = data1, xls_range=A1:G105, mh_jscale=0.3, mode_check, bayesian_irf);


 
 
